<html>
<head>
<title>RManNotes: Writing Shaders: Displacement</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="writing_shaders.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="surf2.html">previous</a>
|
<i>next</i>
|
<a href="index.html">writing shaders: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1>Displacement Shaders</h1>

<p>
We can used the same divide and conquer approach with displacement shaders 
that we did with surface shaders.
We will break down the surface displacement into simple layers and 
then composite the layers to create the final effect.
</p>

<h2><a name="vars">Variables</a></h2>

<p>
The table below summarizes local variables that we'll use by
convention in writing displacement shaders.
</p>

<center>
<table border cellpadding=5>
<th align=left>name<th>type<th>description
<tr><td>surface_mag<td>float<td>magnitude of displacement for all composited layers
<tr><td>layer_mag<td>float<td>magnitude of displacement for current layers
<tr><td>Km<td>float<td>overall displacement scaling factor
<tr><td>ss,tt<td>float<td>texture coordinates of current layer (2D)
<tr><td>PP<td>point<td>texture coordinates of current layer (3D)
</table>
</center>

<h2><a name="layers">Layers, Compositing, Displacement</a></h2>

<p>
The local variable <code>surface_mag</code> will be used to represent
the sum magnitude of surface displacement. Initially, we'll assign this a
value (frequently zero) which represents the displacement for the background
layer.
</p>

<p><pre><small>
	surface_mag = 0;
</pre></small></p>

<p>
For each layer in the displacement shader, we'll assign a value to 
<code>layer_mag</code> which will represent the amount of displacement
contributed by that layer. One cool thing about displacement shaders
is that there are many ways to composite the layers.
Here are three:
<ol>
<li>Just add. This gives a cumulative effect (as you would expect). Each
layer will interfere with the others.
<br><pre><small>
surface_mag += layer_mag;
</pre></small>
<li>Use max. This gives the effect of layers which don't interfere
with other layers.<br>
<pre><small>surface_mag = max(surface_mag, layer_mag);</pre></small>
<li>Use max and add.<br>
<pre><small>surface_mag = max(surface_mag, layer_mag) + layer_mag;</pre></small>
</ol>
</p>

<p>
When all the layers have been composited, we can move the surface point
along the normal with a small amount of shader code shown in the
fragment below. <code>P</code> and
<code>N</code> are RSL global variables specifying the surface point
and normal. <code>Km</code> is a local variable or more likely an instance
parameter which allows the total surface displacement to be scaled
by the user.
</p>

<p><pre><small>
	P += P * Km * surface_mag * normalize(N);
	N = calculatenormal(P);
</small></pre></p>

<p>
The table below shows 3 variations of the same shader. 
The only difference is in the way that the top-most layer (layer #2)
is composited.
</p>

<center>
<table>
<tr><td><a href="disp1.1.jpg"><img src="disp1.1.gif"></a><td><a href="disp1.2.jpg"><img src="disp1.2.gif"></a><td><a href="disp1.3.jpg"><img src="disp1.3.gif"></a>
<tr align=center><td><a href="disp1.1.sl">just adding</a><td><a href="disp1.2.sl">max</a><td><a href="disp1.3.sl">max plus add</a>
</table>
</center>



<h2><a name="smooth">Dealing With Smooth-shaded Polygons</a></h2>

<p>
Smooth-shaded polygonal surfaces present a special problem with 
displacement shaders. Although the smooth shading surface normals 
give the polygonal data a smooth, non-faceted look with surface shaders, 
the polygons are still flat and therefore displacement of surface points 
in a displacement shader returns the faceted shading.
</p>

<center>
<table>
<tr><td><a href="disp1.4a.jpg"><img src="disp1.4a.gif"></a><td><a href="disp1.4b.jpg"><img src="disp1.4b.gif"></a><td><a href="disp1.4c.jpg"><img src="disp1.4c.gif"></a>
<tr align=center><td>polygonal sphere<td>polygonal sphere<br>w/smooth shading<td>polygonal sphere<br>w/smooth shading<br>&amp; displacement shader
</table>
</center>

<p>
With smooth-shaded polygons, <code>N</code> (shading normal) will contain
the smooth shading normal and <code>Ng</code> (geometric normal) will contain
the face normal. We can solve the displacement problem by saving the
difference between <code>N</code> and <code>Ng</code> and then adding
it back in after we calculate the new normal. The code fragment below
demonstrates this:
</p>

<p><pre><small>
	point Ndiff;
	.
	.
	Ndiff = normalize(N) - normalize(Ng);
	P += P * Km * surface_mag * normalize(N);
	N = normalize(calculatenormal(P)) + Ndiff;
</small></pre></p>

<p>
The image below shows a smooth-shaded polygonal sphere with the
<a href="disp1.4.sl">disp1.4.sl</a> displacement shader applied to it. 
This shader is the same as <a href="disp1.3.sl">disp1.3.sl</a>
modified with the code fragment given above. 
Note that the faceted look has disappeared!
</p>

<p align=center>
<a href="disp1.4d.jpg"><img src="disp1.4d.gif"></a><br>
<a href="disp1.4.sl">disp1.4.sl</a>
</p>

<p><img src="black_line.gif"></p>
<p>
<a href="surf2.html">previous</a>
|
<i>next</i>
|
<a href="index.html">writing shaders: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 5/7/96</i></small></p>

</body>
</html>
